								MEMBER

								MAP
								END

	INCLUDE('CM_Text_RTF.inc'),once
	include('CM_System_String.inc'),once


CM_Text_RTF.Construct           procedure
	code 
	self.HeaderText = '{{\rtf1\ansi\ansicpg1252\deff0\deflang4105' |
		& '{{\fonttbl{{\f0\fnil\fcharset0 MS Sans Serif;}}' 
	self.ColorsQ &= new CM_Text_RTF_ColorsQueue
	self.HighlightsQ &= new CM_Test_RTF_HighlightsQueue
			
CM_Text_RTF.Destruct            procedure
	code 
	free(self.ColorsQ)
	dispose(self.ColorsQ)
	free(self.HighlightsQ)
	dispose(self.HighlightsQ)
	
CM_Text_RTF.GetColorTableEntry  procedure(long color)!,string,private	
clr                                 Long
rgb                                 Group,Over(clr)
red                                     Byte
green                                   Byte
blue                                    Byte
reserved                                Byte
									End
	CODE
	clr = color 
	return '\red' & rgb.red & '\green' & rgb.green & '\blue' & rgb.blue & ';'
	
	

CM_Text_RTF.GetText             procedure !,STRING
rtfStr                              CM_System_String
docStr                              CM_System_String
x                                   long
	code
	rtfStr.Assign(self.HeaderText)
	rtfStr.Append('{{\colortbl ;')
	rtfStr.Append(self.GetColorTableEntry(color:black))
	loop x = 1 to records(self.ColorsQ)
		get(self.ColorsQ,x)
		rtfStr.Append(self.GetColorTableEntry(self.ColorsQ.Color))
	END
	rtfStr.Append('}{{\*\generator Msftedit 5.41.21.2509;}')
	rtfStr.Append('\viewkind4\uc1\pard\cf1\highlight0\f0\fs17 ')
	! Do the text highlighting
	docStr.Assign(self.text)
	loop x = 1 to records(self.HighlightsQ)
		get(self.HighlightsQ,x)
		self.ColorsQ.Color = self.HighlightsQ.FgColor
		get(self.ColorsQ,self.ColorsQ.Color)
		docStr.Replace(self.HighlightsQ.Text,|
			'\cf' & pointer(self.ColorsQ)+1  & ' '|
			 & self.HighlightsQ.Text & '\cf1 ',,true)
	END
	rtfStr.Append(docstr.Get())
	rtfStr.Append('}')
	return rtfStr.Get()

	
	
CM_Text_RTF.HighlightText       procedure(string text,long fgColor)
	CODE
	self.ColorsQ.Color = fgColor
	get(self.ColorsQ,self.ColorsQ.Color)
	if errorcode()
		self.ColorsQ.Color = fgColor
		add(self.ColorsQ,self.ColorsQ.Color)
	END
	self.HighlightsQ.text = text
	get(self.HighlightsQ,self.HighlightsQ.text)
	if errorcode()
		self.HighlightsQ.text = text
		self.HighlightsQ.FgColor = fgColor
		add(self.HighlightsQ,self.HighlightsQ.text)
	END	
		
	
CM_Text_RTF.SetText             procedure(string text)
	code 
	self.Text = text
	

