

   MEMBER('rtfnotepad.clw')                                ! This is a MEMBER module


   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('RTFNOTEPAD002.INC'),ONCE        !Local module procedure declarations
                     END


!!! <summary>
!!! Generated from procedure template - Window
!!! Update the Customers File
!!! </summary>
UpdateCustomer PROCEDURE 

CurrentTab           STRING(80)                            !
ActionMessage        CSTRING(40)                           !
History::CUS:Record  LIKE(CUS:RECORD),THREAD
QuickWindow          WINDOW('Update the Customers File'),AT(,,223,147),FONT('MS Sans Serif',8),RESIZE,CENTER,GRAY, |
  IMM,MDI,HLP('UpdateCustomer'),SYSTEM
                       BOX,AT(0,0,49,147),USE(?Box1),FULL,COLOR(COLOR:Gray),FILL(COLOR:Silver)
                       PROMPT('First Name:'),AT(4,8),USE(?CUS:FirstName:Prompt),FONT(,,COLOR:Navy,FONT:bold,CHARSET:ANSI), |
  TRN
                       ENTRY(@s40),AT(57,8,164,10),USE(CUS:FirstName),FLAT
                       PROMPT('Last Name:'),AT(4,22),USE(?CUS:LastName:Prompt),FONT(,,COLOR:Navy,FONT:bold,CHARSET:ANSI), |
  TRN
                       ENTRY(@s40),AT(57,22,164,10),USE(CUS:LastName),FLAT
                       PROMPT('Address 1:'),AT(4,36),USE(?CUS:Address1:Prompt),FONT(,,COLOR:Navy,FONT:bold,CHARSET:ANSI), |
  TRN
                       ENTRY(@s40),AT(57,36,164,10),USE(CUS:Address1),FLAT
                       PROMPT('Address 2:'),AT(4,50),USE(?CUS:Address2:Prompt),FONT(,,COLOR:Navy,FONT:bold,CHARSET:ANSI), |
  TRN
                       ENTRY(@s40),AT(57,50,164,10),USE(CUS:Address2),FLAT
                       PROMPT('City:'),AT(4,64),USE(?CUS:City:Prompt),FONT(,,COLOR:Navy,FONT:bold,CHARSET:ANSI),TRN
                       ENTRY(@s40),AT(57,64,164,10),USE(CUS:City),FLAT
                       PROMPT('State:'),AT(4,78),USE(?CUS:State:Prompt),FONT(,,COLOR:Navy,FONT:bold,CHARSET:ANSI), |
  TRN
                       ENTRY(@s2),AT(57,78,40,10),USE(CUS:State),FLAT
                       PROMPT('Zip:'),AT(4,92),USE(?CUS:Zip:Prompt),FONT(,,COLOR:Navy,FONT:bold,CHARSET:ANSI),TRN
                       ENTRY(@K<<<<<|-<<<<K),AT(57,92,104,10),USE(CUS:Zip),OVR,FLAT
                       CHECK('Print Invoice'),AT(57,106,70,10),USE(CUS:PrintInvoice),FONT(,,COLOR:Navy,FONT:bold, |
  CHARSET:ANSI),MSG('True or False flag for generating a hardcopy invoice'),TIP('True or Fa' & |
  'lse flag for generating a hardcopy invoice'),TRN
                       BUTTON('OK'),AT(57,129,36,14),USE(?OK),LEFT,ICON('WAOK.ICO'),DEFAULT,FLAT
                       BUTTON('Cancel'),AT(170,129,47,14),USE(?Cancel),LEFT,ICON('WACANCEL.ICO'),FLAT
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END

CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Adding a Customers Record'
  OF ChangeRecord
    ActionMessage = 'Changing a Customers Record'
  END
  QuickWindow{PROP:Text} = ActionMessage                   ! Display status message in title bar
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateCustomer')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Box1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.HistoryKey = 734
  SELF.AddHistoryFile(CUS:Record,History::CUS:Record)
  SELF.AddHistoryField(?CUS:FirstName,2)
  SELF.AddHistoryField(?CUS:LastName,3)
  SELF.AddHistoryField(?CUS:Address1,4)
  SELF.AddHistoryField(?CUS:Address2,5)
  SELF.AddHistoryField(?CUS:City,6)
  SELF.AddHistoryField(?CUS:State,7)
  SELF.AddHistoryField(?CUS:Zip,8)
  SELF.AddHistoryField(?CUS:PrintInvoice,9)
  SELF.AddUpdateFile(Access:Customers)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:Customers.Open                                    ! File Customers used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:Customers
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Customers.Close
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

