

   MEMBER('rtfnotepad.clw')                                ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE
   INCLUDE('rtfctl.inc'),ONCE

                     MAP
                       INCLUDE('RTFNOTEPAD005.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('RTFNOTEPAD002.INC'),ONCE        !Req'd for module callout resolution
                       INCLUDE('RTFNOTEPAD003.INC'),ONCE        !Req'd for module callout resolution
                       INCLUDE('RTFNOTEPAD007.INC'),ONCE        !Req'd for module callout resolution
                     END


!!! <summary>
!!! Generated from procedure template - Window
!!! Browse the Customers File
!!! </summary>
BrowseCustomersNew PROCEDURE 

CurrentTab           STRING(80)                            !
dirty                BYTE                                  !
BRW1::View:Browse    VIEW(Customers)
                       PROJECT(CUS:FirstName)
                       PROJECT(CUS:LastName)
                       PROJECT(CUS:Address1)
                       PROJECT(CUS:Address2)
                       PROJECT(CUS:City)
                       PROJECT(CUS:State)
                       PROJECT(CUS:Zip)
                       PROJECT(CUS:PrintInvoice)
                       PROJECT(CUS:SysID)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
CUS:FirstName          LIKE(CUS:FirstName)            !List box control field - type derived from field
CUS:LastName           LIKE(CUS:LastName)             !List box control field - type derived from field
CUS:Address1           LIKE(CUS:Address1)             !List box control field - type derived from field
CUS:Address2           LIKE(CUS:Address2)             !List box control field - type derived from field
CUS:City               LIKE(CUS:City)                 !List box control field - type derived from field
CUS:State              LIKE(CUS:State)                !List box control field - type derived from field
CUS:Zip                LIKE(CUS:Zip)                  !List box control field - type derived from field
CUS:PrintInvoice       LIKE(CUS:PrintInvoice)         !List box control field - type derived from field
CUS:SysID              LIKE(CUS:SysID)                !Primary key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
BRW5::View:Browse    VIEW(Letters)
                       PROJECT(LET:LetterName)
                       PROJECT(LET:SysID)
                       PROJECT(LET:Letter)
                     END
Queue:Browse         QUEUE                            !Queue declaration for browse/combo box using ?List
LET:LetterName         LIKE(LET:LetterName)           !List box control field - type derived from field
LET:SysID              LIKE(LET:SysID)                !List box control field - type derived from field
LET:Letter             STRING(SIZE(LET:Letter))       !List box control field - STRING defined to hold MEMO's contents
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Browse Customers  -  Selected Customer Info Used To Replace Tokens in Letters'),AT(, |
  ,422,293),FONT('MS Sans Serif',8),RESIZE,AUTO,CENTER,GRAY,IMM,MDI,HLP('BrowseCustomers'), |
  SYSTEM
                       SHEET,AT(2,0,418,120),USE(?CurrentTab),WIZARD
                         TAB('Customers'),USE(?Tab:2)
                           LIST,AT(9,7,406,92),USE(?Browse:1),HVSCROLL,FLAT,FORMAT('80L(2)|M~First Name~@s40@80L(2' & |
  ')|M~Last Name~@s40@80L(2)|M~Address 1~@s40@80L(2)|M~Address 2~@s40@80L(2)|M~City~@s4' & |
  '0@24L(2)|M~State~@s2@80L(2)|M~Zip~@K<<<<<<<<<<|-<<<<<<<<K@56R(2)|M~Print Invoice~C(0)@n3@'), |
  FROM(Queue:Browse:1),IMM,MSG('Browsing Records')
                           BUTTON('&Insert'),AT(131,102,45,14),USE(?Insert:2),LEFT,ICON('WAINSERT.ICO'),FLAT,SKIP
                           BUTTON('&Change'),AT(181,102,53,14),USE(?Change:2),LEFT,ICON('WACHANGE.ICO'),DEFAULT,FLAT, |
  SKIP
                           BUTTON('&Delete'),AT(239,102,45,14),USE(?Delete:2),LEFT,ICON('WADELETE.ICO'),FLAT,SKIP
                         END
                       END
                       SHEET,AT(2,120,418,171),USE(?Sheet2)
                         TAB('Letters'),USE(?Tab3)
                           LIST,AT(7,139,99,122),USE(?List),VSCROLL,FLAT,FORMAT('173L(10)|M~Letter Name~@s40@56R(2' & |
  ')|M~Sys ID~L@n-14@320L(2)|M~Letter~@s80@'),FROM(Queue:Browse),IMM,MSG('Browsing Records')
                           TEXT,AT(112,139,302,122),USE(LET:Letter),RTF(TEXT:Field),VSCROLL,BOXED,SKIP
                           BUTTON('Insert'),AT(7,268,41,14),USE(?Insert),LEFT,ICON('WAINSERT.ICO'),FLAT,SKIP,TIP('Insert a new Letter')
                           BUTTON('Change'),AT(52,268,49,14),USE(?Change),LEFT,ICON('WACHANGE.ICO'),FLAT,SKIP,TIP('Change a L' & |
  'etter record')
                           BUTTON('Delete'),AT(105,268,45,14),USE(?Delete),LEFT,ICON('WADELETE.ICO'),FLAT,SKIP,TIP('Delete a L' & |
  'etter record')
                           BUTTON('Replace Field Tokens (code templates), before Printing'),AT(161,265,142,20),USE(?Merge), |
  FONT(,,COLOR:Green,FONT:bold,CHARSET:ANSI),LEFT,ICON('Rreplace.ico'),FLAT,SKIP
                           BUTTON('Print Letters'),AT(310,265,52,20),USE(?PrintL),LEFT,ICON(ICON:Print1),FLAT,SKIP
                         END
                       END
                       BUTTON('Close'),AT(369,268,43,14),USE(?Close),LEFT,ICON('WACLOSE.ICO'),FLAT
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
TakeEvent              PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW1::Sort0:StepClass StepStringClass                      ! Default Step Manager
BRW5                 CLASS(BrowseClass)                    ! Browse using ?List
Q                      &Queue:Browse                  !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

BRW5::Sort0:Locator  StepLocatorClass                      ! Default Locator
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END

RTFControl7          CLASS(RTFControlClass)
ContextMenuText        PROCEDURE(),STRING,DERIVED
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('BrowseCustomersNew')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Create(TLetters)
  IF Errorcode(); STOP(Error()).
  Relate:Customers.Open                                    ! File Customers used by this procedure, so make sure it's RelationManager is open
  Relate:Letters.Open                                      ! File Letters used by this procedure, so make sure it's RelationManager is open
  Relate:TLetters.Open                                     ! File TLetters used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:Customers,SELF) ! Initialize the browse manager
  BRW5.Init(?List,Queue:Browse.ViewPosition,BRW5::View:Browse,Queue:Browse,Relate:Letters,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse:1
  BRW1.ActiveInvisible = 1
  BRW1::Sort0:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime) ! Moveable thumb based upon CUS:LastName for sort order 1
  BRW1.AddSortOrder(BRW1::Sort0:StepClass,CUS:NameKEY)     ! Add the sort order for CUS:NameKEY for sort order 1
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort0:Locator.Init(,CUS:LastName,1,BRW1)           ! Initialize the browse locator using  using key: CUS:NameKEY , CUS:LastName
  BRW1.AddField(CUS:FirstName,BRW1.Q.CUS:FirstName)        ! Field CUS:FirstName is a hot field or requires assignment from browse
  BRW1.AddField(CUS:LastName,BRW1.Q.CUS:LastName)          ! Field CUS:LastName is a hot field or requires assignment from browse
  BRW1.AddField(CUS:Address1,BRW1.Q.CUS:Address1)          ! Field CUS:Address1 is a hot field or requires assignment from browse
  BRW1.AddField(CUS:Address2,BRW1.Q.CUS:Address2)          ! Field CUS:Address2 is a hot field or requires assignment from browse
  BRW1.AddField(CUS:City,BRW1.Q.CUS:City)                  ! Field CUS:City is a hot field or requires assignment from browse
  BRW1.AddField(CUS:State,BRW1.Q.CUS:State)                ! Field CUS:State is a hot field or requires assignment from browse
  BRW1.AddField(CUS:Zip,BRW1.Q.CUS:Zip)                    ! Field CUS:Zip is a hot field or requires assignment from browse
  BRW1.AddField(CUS:PrintInvoice,BRW1.Q.CUS:PrintInvoice)  ! Field CUS:PrintInvoice is a hot field or requires assignment from browse
  BRW1.AddField(CUS:SysID,BRW1.Q.CUS:SysID)                ! Field CUS:SysID is a hot field or requires assignment from browse
  BRW5.Q &= Queue:Browse
  BRW5.ActiveInvisible = 1
  BRW5.AddSortOrder(,LET:NameKEY)                          ! Add the sort order for LET:NameKEY for sort order 1
  BRW5.AddLocator(BRW5::Sort0:Locator)                     ! Browse has a locator for sort order 1
  BRW5::Sort0:Locator.Init(,LET:LetterName,1,BRW5)         ! Initialize the browse locator using  using key: LET:NameKEY , LET:LetterName
  BRW5.AddField(LET:LetterName,BRW5.Q.LET:LetterName)      ! Field LET:LetterName is a hot field or requires assignment from browse
  BRW5.AddField(LET:SysID,BRW5.Q.LET:SysID)                ! Field LET:SysID is a hot field or requires assignment from browse
  BRW5.AddField(LET:Letter,BRW5.Q.LET:Letter)              ! Field LET:Letter is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  RTFControl7.Init(?LET:Letter)
  BRW1.AskProcedure = 1
  BRW5.AskProcedure = 2
  BRW5.AddToolbarTarget(Toolbar)                           ! Browse accepts toolbar control
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Customers.Close
    Relate:Letters.Close
    Relate:TLetters.Close
  END
  RTFControl7.Kill()
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    EXECUTE Number
      UpdateCustomer
      UpdateLetter
    END
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?Merge
      ThisWindow.Update
      RTFControl7.FindAndReplace(CLIP('CUS:LastName'),CLIP(CUS:LastName))
      RTFControl7.FindAndReplace(CLIP('CUS:FirstName'),CLIP(CUS:FirstName))
      RTFControl7.FindAndReplace(CLIP('CUS:Address1'),CLIP(CUS:Address1))
      RTFControl7.FindAndReplace(CLIP('CUS:Address2'),CLIP(CUS:Address2))
      RTFControl7.FindAndReplace(CLIP('CUS:City'),CLIP(CUS:City))
      RTFControl7.FindAndReplace(CLIP('CUS:State'),CLIP(CUS:State))
      RTFControl7.FindAndReplace(CLIP('CUS:Zip'),CLIP(CUS:Zip))
      ! Add to temp file
      Update(LET:Letter)
      TLT:LetterName = LET:LetterName
      TLT:Letter = LET:Letter
      Access:TLetters.Insert()
      !Re-select Letter list
      SELECT(?LIST)
    OF ?PrintL
      ThisWindow.Update
      PrintRTFLetter()
      ThisWindow.Reset
      !Select Customer list
      SELECT(?Browse:1)
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = RTFControl7.TakeEvent()
  ReturnValue = PARENT.TakeEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert:2
    SELF.ChangeControl=?Change:2
    SELF.DeleteControl=?Delete:2
  END


BRW5.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert
    SELF.ChangeControl=?Change
    SELF.DeleteControl=?Delete
  END


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window
  SELF.SetStrategy(?List, Resize:FixLeft, Resize:LockWidth) ! Override strategy for ?List


RTFControl7.ContextMenuText PROCEDURE

ReturnValue          ANY

  CODE
  ReturnValue = PARENT.ContextMenuText()
  ReturnValue = ''
  RETURN ReturnValue

